Index: npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest
===================================================================
--- npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision cd8630be6536b27ae1c762184795ee87723202ab)
+++ npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision 1ebb340be23e45ead361b729734f0e82007af6bd)
@@ -25461,13 +25531,13 @@
 +      relayclient = "";
 +      remoteinfo = user.s;
-+      if (!env_unset("TCPREMOTEINFO")) die_read();
++      if (!env_unset("TCPREMOTEINFO")) die_read("TCPREMOTEINFO");
 +      if (!env_put2("TCPREMOTEINFO",remoteinfo)) die_nomem();
 +      if (!env_put2("RELAYCLIENT",relayclient)) die_nomem();
 +
-+      if (!env_unset("SMTPAUTHMETHOD")) die_read();
++      if (!env_unset("SMTPAUTHMETHOD")) die_read("SMTPAUTHMETHOD");
 +      if (!env_put2("SMTPAUTHMETHOD", authcmds[i].text)) die_nomem();
-+      if (!env_unset("SMTPAUTHUSER")) die_read();
++      if (!env_unset("SMTPAUTHUSER")) die_read("SMTPAUTHUSER");
 +      if (!env_put2("SMTPAUTHUSER",user.s)) die_nomem();
-+      if (!env_unset("SMTP_AUTH_USER")) die_read();
++      if (!env_unset("SMTP_AUTH_USER")) die_read("SMTP_AUTH_USER");
 +      if (!env_put2("SMTP_AUTH_USER",user.s)) die_nomem();
 +
@@ -25495,23 +25565,36 @@
 +RSA *tmp_rsa_cb(SSL *ssl, int export, int keylen)
 +{
++  RSA *rsa;
++
 +  if (!export) keylen = 2048;
 +  if (keylen == 2048) {
 +    FILE *in = fopen("control/rsa2048.pem", "r");
 +    if (in) {
-+      RSA *rsa = PEM_read_RSAPrivateKey(in, NULL, NULL, NULL);
++      rsa = PEM_read_RSAPrivateKey(in, NULL, NULL, NULL);
 +      fclose(in);
 +      if (rsa) return rsa;
 +    }
 +  }
++#if OPENSSL_VERSION_NUMBER >= 0x10100000L
++  BIGNUM *e; /*exponent */
++  e = BN_new();
++  BN_set_word(e, RSA_F4);
++  if (RSA_generate_key_ex(rsa, keylen, e, NULL) == 1)
++    return rsa;
++  return NULL;
++#else
 +  return RSA_generate_key(keylen, RSA_F4, NULL, NULL);
++#endif
 +}
 +
 +DH *tmp_dh_cb(SSL *ssl, int export, int keylen)
 +{
++  DH *dh;
++
 +  if (!export) keylen = 2048;
 +  if (keylen == 2048) {
 +    FILE *in = fopen("control/dh2048.pem", "r");
 +    if (in) {
-+      DH *dh = PEM_read_DHparams(in, NULL, NULL, NULL);
++      dh = PEM_read_DHparams(in, NULL, NULL, NULL);
 +      fclose(in);
 +      if (dh) return dh;
@@ -25526,9 +25609,15 @@
 +    }
 +  }
++#if OPENSSL_VERSION_NUMBER >= 0x10100000L
++  if((dh = DH_new()) && (DH_generate_parameters_ex(dh, keylen, DH_GENERATOR_2, NULL) == 1))
++    return dh;
++  return NULL;
++#else
 +  return DH_generate_parameters(keylen, DH_GENERATOR_2, NULL, NULL);
-+} 
++#endif
++}
 +
 +/* don't want to fail handshake if cert isn't verifiable */
-+int verify_cb(int preverify_ok, X509_STORE_CTX *ctx) { return 1; }
++int verify_cb(int preverify_ok, X509_STORE_CTX *x509_ctx) { return 1; }
 +
 +void tls_nogateway()
@@ -25545,5 +25634,5 @@
 +  out(" (#4.3.0)\r\n"); flush();
 +}
-+void tls_err(const char *s) { tls_out(s, ssl_error()); if (smtps) die_read(); }
++void tls_err(const char *s) { tls_out(s, ssl_error()); if (smtps) die_read("tls_err"); }
 +
 +# define CLIENTCA "control/clientca.pem"
@@ -25572,5 +25661,5 @@
 +      if (sk) {
 +        SSL_set_client_CA_list(ssl, sk);
-+        SSL_set_verify(ssl, SSL_VERIFY_PEER | SSL_VERIFY_CLIENT_ONCE, NULL);
++        SSL_set_verify(ssl, SSL_VERIFY_PEER, verify_cb);
 +        break;
 +      }
@@ -25583,5 +25672,5 @@
 +  if (ssl_timeoutrehandshake(timeout, ssl_rfd, ssl_wfd, ssl) <= 0) {
 +    const char *err = ssl_error_str();
-+    tls_out("rehandshake failed", err); die_read();
++    tls_out("rehandshake failed", err); die_read("rehandshake failed");
 +  }
 +
@@ -25600,5 +25689,5 @@
 +    n = X509_NAME_get_index_by_NID(subj, NID_pkcs9_emailAddress, -1);
 +    if (n >= 0) {
-+      const ASN1_STRING *s = X509_NAME_get_entry(subj, n)->value;
++      const ASN1_STRING *s = X509_NAME_ENTRY_get_data(X509_NAME_get_entry(subj, n));
 +      if (s) { email.len = s->length; email.s = s->data; }
 +    }
@@ -25640,4 +25729,5 @@
 +  X509_STORE *store;
 +  X509_LOOKUP *lookup;
++  int session_id_context = 1; /* anything will do */
 +
 +  SSL_library_init();
@@ -25650,9 +25740,20 @@
 +  SSL_CTX_set_options(ctx, SSL_OP_NO_SSLv2 | SSL_OP_NO_SSLv3);
 +
++  /* renegotiation should include certificate request */
++  SSL_CTX_set_options(ctx, SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION);
++
++  /* never bother the application with retries if the transport is blocking */
++  SSL_CTX_set_mode(ctx, SSL_MODE_AUTO_RETRY);
++
++  /* relevant in renegotiation */
++  SSL_CTX_set_session_cache_mode(ctx, SSL_SESS_CACHE_OFF);
++  if (!SSL_CTX_set_session_id_context(ctx, (void *)&session_id_context,
++                                        sizeof(session_id_context))) 
++    { SSL_CTX_free(ctx); tls_err("failed to set session_id_context"); return; }
++
 +  if (!SSL_CTX_use_certificate_chain_file(ctx, SERVERCERT))
 +    { SSL_CTX_free(ctx); tls_err("missing certificate"); return; }
 +  SSL_CTX_load_verify_locations(ctx, CLIENTCA, NULL);
 +
-+#if OPENSSL_VERSION_NUMBER >= 0x00907000L
 +  /* crl checking */
 +  store = SSL_CTX_get_cert_store(ctx);
@@ -25661,5 +25762,4 @@
 +    X509_STORE_set_flags(store, X509_V_FLAG_CRL_CHECK |
 +                                X509_V_FLAG_CRL_CHECK_ALL);
-+#endif
 +
 +#if OPENSSL_VERSION_NUMBER >= 0x10002000L
@@ -25668,6 +25768,5 @@
 +#endif
 +
-+  /* set the callback here; SSL_set_verify didn't work before 0.9.6c */
-+  SSL_CTX_set_verify(ctx, SSL_VERIFY_NONE, verify_cb);
++  SSL_CTX_set_verify(ctx, SSL_VERIFY_NONE, NULL);
 +
 +  /* a new SSL object, with the rest added to it directly to avoid copying */
@@ -25705,5 +25804,5 @@
 +    /* neither cleartext nor any other response here is part of a standard */
 +    const char *err = ssl_error_str();
-+    ssl_free(myssl); tls_out("connection failed", err); die_read();
++    tls_out("connection failed", err); ssl_free(myssl); die_read("tls connection failed");
 +  }
 +  ssl = myssl;
@@ -25878,9 +25977,18 @@
    smtp_greet("220 ");
    out(" ESMTP\r\n");
-   if (commands(&ssin,&smtpcommands) == 0) die_read();
+-  if (commands(&ssin,&smtpcommands) == 0) die_read();
++  if (commands(&ssin,&smtpcommands) == 0) die_read("commands");
+   die_nomem();
+ }
 diff -ruN ../netqmail-1.06-original/qmail-start.c netqmail-1.06/qmail-start.c
 --- ../netqmail-1.06-original/qmail-start.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-start.c	2016-11-22 21:03:57.125527665 +0100
-@@ -8,6 +8,9 @@
++++ netqmail-1.06/qmail-start.c	2019-06-26 16:39:31.578826915 +0200
+@@ -4,10 +4,15 @@
+ #include "fork.h"
+ #include "auto_uids.h"
+ 
++#include "channels.h"
++
+ char *(qsargs[]) = { "qmail-send", 0 };
  char *(qcargs[]) = { "qmail-clean", 0 };
  char *(qlargs[]) = { "qmail-lspawn", "./Mailbox", 0 };
@@ -25892,5 +26000,5 @@
  void die() { _exit(111); }
  
-@@ -18,13 +21,28 @@
+@@ -18,19 +23,51 @@
  int pi4[2];
  int pi5[2];
@@ -25905,12 +26013,21 @@
 +#endif
 +
++int suppl_pi[SUPPL_CHANNELS*2][2];
++
 +void close23456() { 
++  int c;
 +  close(2); close(3); close(4); close(5); close(6); 
 +#ifdef EXTERNAL_TODO
 +  close(7); close(8);
 +#endif
++  for (c=1+CHANNEL_FD_OFFSET;c<=SUPPL_CHANNELS*2+CHANNEL_FD_OFFSET;c++)
++  {
++      close(c);
++  }
 +}
  
  void closepipes() {
++  int c;
++
    close(pi1[0]); close(pi1[1]); close(pi2[0]); close(pi2[1]);
    close(pi3[0]); close(pi3[1]); close(pi4[0]); close(pi4[1]);
@@ -25920,8 +26037,22 @@
 +	close(pi9[0]); close(pi9[1]); close(pi10[0]); close(pi10[1]);
 +#endif
++
++  for (c=0;c<SUPPL_CHANNELS*2;c++)
++  {
++      close(suppl_pi[c][0]);
++      close(suppl_pi[c][1]);
++  }
  }
  
  void main(argc,argv)
-@@ -40,6 +58,10 @@
+ int argc;
+ char **argv;
+ {
++  int c, cc;
++
+   if (chdir("/") == -1) die();
+   umask(077);
+   if (prot_gid(auto_gidq) == -1) die();
+@@ -40,6 +77,14 @@
    if (fd_copy(4,0) == -1) die();
    if (fd_copy(5,0) == -1) die();
@@ -25931,8 +26062,12 @@
 +  if (fd_copy(8,0) == -1) die();
 +#endif
++  for (c=1+CHANNEL_FD_OFFSET;c<=SUPPL_CHANNELS*2+CHANNEL_FD_OFFSET;c++)
++  {
++      if (fd_copy(c,0) == -1) die();
++  }
  
    if (argv[1]) {
      qlargs[1] = argv[1];
-@@ -70,6 +92,12 @@
+@@ -70,6 +115,16 @@
    if (pipe(pi4) == -1) die();
    if (pipe(pi5) == -1) die();
@@ -25944,8 +26079,12 @@
 +  if (pipe(pi10) == -1) die();
 +#endif
++  for (c=0;c<SUPPL_CHANNELS*2;c++)
++  {
++      if (pipe(suppl_pi[c]) == -1) die();
++  }
   
    switch(fork()) {
      case -1: die();
-@@ -106,6 +134,34 @@
+@@ -106,6 +161,57 @@
        die();
    }
@@ -25978,9 +26117,32 @@
 +  }
 +#endif
-+ 
++
++  for (c=0,cc=0;c<SUPPL_CHANNELS;++c,cc+=2)
++  {
++      switch(fork()) {
++        case -1: die();
++        case 0:
++          if (prot_uid(auto_uidr) == -1) die();
++          /* Does not increment cc in parent process */
++          if (fd_copy(0,suppl_pi[cc++][0]) == -1) die();
++          if (fd_copy(1,suppl_pi[cc][1]) == -1) die();
++          close23456();
++          closepipes();
++          /*if (str_equal(channel_types[c],"remote"))
++          {*/
++              execvp(*qrargs,qrargs);
++          /*}
++           else
++          {
++             execvp(*qlargs,qlargs);
++          }*/
++          die();
++      }
++  }
++
    if (prot_uid(auto_uids) == -1) die();
    if (fd_copy(0,1) == -1) die();
    if (fd_copy(1,pi1[1]) == -1) die();
-@@ -114,6 +170,10 @@
+@@ -114,6 +220,17 @@
    if (fd_copy(4,pi4[0]) == -1) die();
    if (fd_copy(5,pi5[1]) == -1) die();
@@ -25990,4 +26152,11 @@
 +  if (fd_copy(8,pi8[0]) == -1) die();
 +#endif
++
++  for (cc=0,c=1+CHANNEL_FD_OFFSET;c<=SUPPL_CHANNELS*2+CHANNEL_FD_OFFSET;c++)
++  {
++      if (fd_copy(c++,suppl_pi[cc++][1]) == -1) die();
++      if (fd_copy(c,suppl_pi[cc++][0]) == -1) die();
++  }
++
    closepipes();
    execvp(*qsargs,qsargs);
@@ -25995,6 +26164,6 @@
 diff -ruN ../netqmail-1.06-original/qmail-todo.c netqmail-1.06/qmail-todo.c
 --- ../netqmail-1.06-original/qmail-todo.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/qmail-todo.c	2016-11-22 21:03:57.126527632 +0100
-@@ -0,0 +1,703 @@
++++ netqmail-1.06/qmail-todo.c	2019-06-26 16:39:31.579826904 +0200
+@@ -0,0 +1,791 @@
 +#include <sys/types.h>
 +#include <sys/stat.h>
@@ -26022,4 +26191,6 @@
 +#include "trigger.h"
 +
++#include "channels.h"
++
 +/* critical timing feature #1: if not triggered, do not busy-loop */
 +/* critical timing feature #2: if triggered, respond within fixed time */
@@ -26030,4 +26201,5 @@
 +#define SLEEP_SYSFAIL 123
 +
++
 +stralloc percenthack = {0};
 +struct constmap mappercenthack;
@@ -26037,10 +26209,12 @@
 +struct constmap mapvdoms;
 +stralloc envnoathost = {0};
++stralloc fname = {0};
 +
 +char strnum[FMT_ULONG];
 +
-+/* XXX not good, if qmail-send.c changes this has to be updated */
-+#define CHANNELS 2
-+char *chanaddr[CHANNELS] = { "local/", "remote/" };
++struct constmap mapsuppl[SUPPL_CHANNELS];
++stralloc suppls[SUPPL_CHANNELS];
++stralloc newsuppls[SUPPL_CHANNELS];
++char *chanaddr[CHANNELS];
 +
 +datetime_sec recent;
@@ -26097,4 +26271,5 @@
 +  int i;
 +  int j;
++  int c;
 +  char *x;
 +  static stralloc addr = {0};
@@ -26139,4 +26314,11 @@
 +  if (!stralloc_cat(&rwline,&addr)) return 0;
 +  if (!stralloc_0(&rwline)) return 0;
++
++  for (c = 0;c < SUPPL_CHANNELS;++c)
++  {
++      if (constmap(&mapsuppl[c],addr.s + at + 1,addr.len - at - 1))
++          return c + 3;
++  }
++
 +  return 2;
 +}
@@ -26206,13 +26388,22 @@
 +}
 +
-+void comm_write(unsigned long id, int local, int remote)
++void comm_write(unsigned long id, int flagchan[])
 +{
 +  int pos;
-+  char *s;
++  char s[CHANNELS+1];
++  int c;
 +  
-+  if(local && remote) s="B";
-+  else if(local) s="L";
-+  else if(remote) s="R";
-+  else s="X";
++  for (c = 0;c < CHANNELS;++c)
++  {
++      if (flagchan[c])
++      {
++          s[c] = '1';
++      }
++      else
++      {
++          s[c] = '0';
++      }
++  }
++  s[c] = 0;
 +  
 +  pos = comm_buf.len;
@@ -26496,10 +26687,7 @@
 +       break;
 +     case 'T':
-+       switch(rewrite(todoline.s + 1))
-+	{
-+	 case 0: nomem(); goto fail;
-+	 case 2: c = 1; break;
-+	 default: c = 0; break;
-+        }
++       c = rewrite(todoline.s + 1);
++       if (c == 0) { nomem(); goto fail; }
++       c--;
 +       if (fdchan[c] == -1)
 +	{
@@ -26553,5 +26741,5 @@
 +  }
 +
-+ comm_write(id, flagchan[0], flagchan[1]);
++ comm_write(id, flagchan);
 + 
 + return;
@@ -26568,4 +26756,6 @@
 +int getcontrols(void)
 +{
++ int c;
++
 + if (control_init() == -1) return 0;
 + if (control_rldef(&envnoathost,"control/envnoathost",1,"envnoathost") != 1) return 0;
@@ -26584,4 +26774,19 @@
 +   case 1: if (!constmap_init(&mapvdoms,vdoms.s,vdoms.len,1)) return 0; break;
 +  }
++
++ for (c = 0;c < SUPPL_CHANNELS;++c)
++ {
++     strnum[fmt_uint(strnum,c)] = 0;
++     if (!stralloc_copys(&fname,"control/suppls")) return 0;
++     if (!stralloc_cats(&fname,strnum)) return 0;
++     if (!stralloc_0(&fname)) return 0;
++     switch (control_readfile(&suppls[c],fname.s,0))
++     {
++         case -1: return 0;
++         case 0: if (!constmap_init(&mapsuppl[c],"",0,0)) return 0; break;
++         case 1: if (!constmap_init(&mapsuppl[c],suppls[c].s,suppls[c].len,0)) return 0; break;
++     }
++ }
++
 + return 1;
 +}
@@ -26593,4 +26798,5 @@
 +{
 + int r;
++ int c;
 +
 + if (control_readfile(&newlocals,"control/locals",1) != 1)
@@ -26613,4 +26819,26 @@
 + else
 +   while (!constmap_init(&mapvdoms,"",0,1)) nomem();
++
++ for (c = 0;c < SUPPL_CHANNELS;++c)
++ {
++     strnum[fmt_uint(strnum,c)] = 0;
++     if (!stralloc_copys(&fname,"control/suppls")) nomem();
++     if (!stralloc_cats(&fname,strnum)) nomem();
++     if (!stralloc_0(&fname)) nomem();
++     r = control_readfile(&newsuppls[c],fname.s,0);
++     if (r == -1)
++      { log3("alert: qmail-todo: unable to reread ", fname.s, "\n"); return; }
++
++     constmap_free(&mapsuppl[c]);
++
++     if (r)
++      {
++       while (!stralloc_copy(&suppls[c],&newsuppls[c])) nomem();
++       while (!constmap_init(&mapsuppl[c],suppls[c].s,suppls[c].len,0)) nomem();
++      }
++     else
++       while (!constmap_init(&mapsuppl[c],"",0,0)) nomem();
++ }
++
 +}
 +
@@ -26630,4 +26858,31 @@
 +}
 +
++static int static_i = 0;
++static int static_j = 0;
++void channels_init(void)
++{
++    for (static_i=0;static_i<SUPPL_CHANNELS;static_i++)
++        suppls[static_i].s = 0;
++
++    for (static_i=0;static_i<SUPPL_CHANNELS;static_i++)
++        newsuppls[static_i].s = 0;
++
++    chanaddr[0] = "local/";
++    chanaddr[1] = "remote/";
++    static_j = 0;
++    for (static_i=2;static_i<CHANNELS;static_i++)
++    {
++        stralloc fnc = {0};
++        strnum[fmt_uint(strnum,static_j++)] = 0;
++        if (!stralloc_copys(&fname,QDIR_BASENAME)) nomem();
++        if (!stralloc_cats(&fname,strnum)) nomem();
++        if (!stralloc_cats(&fname,"/")) nomem();
++        if (!stralloc_0(&fname)) nomem();
++        if (!stralloc_copy(&fnc,&fname)) nomem();
++        chanaddr[static_i] = fnc.s;
++    }
++}
++
++
 +void main()
 +{
@@ -26639,4 +26894,6 @@
 + int r;
 + char c;
++
++ channels_init();
 +
 + if (chdir(auto_qmail) == -1)
@@ -26700,7 +26957,18 @@
 +}
 +
+diff -ruN ../netqmail-1.06-original/qmail-upq.sh netqmail-1.06/qmail-upq.sh
+--- ../netqmail-1.06-original/qmail-upq.sh	1998-06-15 12:53:16.000000000 +0200
++++ netqmail-1.06/qmail-upq.sh	2019-06-26 16:39:31.579826904 +0200
+@@ -1,6 +1,6 @@
+ cd QMAIL
+ cd queue
+-for dir in mess info local remote
++for dir in mess info local remote suppl*
+ do
+   ( cd $dir; find . -type f -print ) | (
+     cd $dir
 diff -ruN ../netqmail-1.06-original/qmail.c netqmail-1.06/qmail.c
 --- ../netqmail-1.06-original/qmail.c	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/qmail.c	2016-11-22 21:03:57.126527632 +0100
++++ netqmail-1.06/qmail.c	2019-02-27 20:57:13.404024915 +0100
 @@ -23,22 +23,32 @@
  {
@@ -26800,5 +27068,5 @@
 diff -ruN ../netqmail-1.06-original/qmail.h netqmail-1.06/qmail.h
 --- ../netqmail-1.06-original/qmail.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail.h	2016-11-22 21:03:57.126527632 +0100
++++ netqmail-1.06/qmail.h	2019-02-27 20:57:13.404024915 +0100
 @@ -3,11 +3,13 @@
  
@@ -26817,5 +27085,5 @@
 diff -ruN ../netqmail-1.06-original/qregex.c netqmail-1.06/qregex.c
 --- ../netqmail-1.06-original/qregex.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/qregex.c	2016-11-22 21:03:57.126527632 +0100
++++ netqmail-1.06/qregex.c	2019-02-27 20:57:13.405024904 +0100
 @@ -0,0 +1,239 @@
 +/*
@@ -27060,5 +27328,5 @@
 diff -ruN ../netqmail-1.06-original/qregex.h netqmail-1.06/qregex.h
 --- ../netqmail-1.06-original/qregex.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/qregex.h	2016-11-22 21:03:57.126527632 +0100
++++ netqmail-1.06/qregex.h	2019-02-27 20:57:13.405024904 +0100
 @@ -0,0 +1,24 @@
 +/*
@@ -27088,5 +27356,5 @@
 diff -ruN ../netqmail-1.06-original/readwrite.h netqmail-1.06/readwrite.h
 --- ../netqmail-1.06-original/readwrite.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/readwrite.h	2016-11-22 21:03:57.126527632 +0100
++++ netqmail-1.06/readwrite.h	2019-02-27 20:57:13.405024904 +0100
 @@ -1,7 +1,6 @@
  #ifndef READWRITE_H
@@ -27100,5 +27368,5 @@
 diff -ruN ../netqmail-1.06-original/received.c netqmail-1.06/received.c
 --- ../netqmail-1.06-original/received.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/received.c	2016-11-22 21:03:57.127527599 +0100
++++ netqmail-1.06/received.c	2019-02-27 20:57:13.405024904 +0100
 @@ -21,6 +21,9 @@
    return 0;
@@ -27128,5 +27396,5 @@
 diff -ruN ../netqmail-1.06-original/remoteinfo.c netqmail-1.06/remoteinfo.c
 --- ../netqmail-1.06-original/remoteinfo.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/remoteinfo.c	2016-11-22 21:03:57.127527599 +0100
++++ netqmail-1.06/remoteinfo.c	2019-02-27 20:57:13.405024904 +0100
 @@ -44,12 +44,12 @@
    s = socket(AF_INET,SOCK_STREAM,0);
@@ -27147,5 +27415,5 @@
 diff -ruN ../netqmail-1.06-original/scan.h netqmail-1.06/scan.h
 --- ../netqmail-1.06-original/scan.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/scan.h	2018-03-31 14:54:40.767441567 +0200
++++ netqmail-1.06/scan.h	2019-02-27 20:57:13.405024904 +0100
 @@ -2,6 +2,7 @@
  #define SCAN_H
@@ -27158,5 +27426,5 @@
 diff -ruN ../netqmail-1.06-original/scan_ulong.c netqmail-1.06/scan_ulong.c
 --- ../netqmail-1.06-original/scan_ulong.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/scan_ulong.c	2016-11-22 21:03:57.127527599 +0100
++++ netqmail-1.06/scan_ulong.c	2019-02-27 20:57:13.405024904 +0100
 @@ -9,3 +9,43 @@
      { result = result * 10 + c; ++pos; }
@@ -27205,5 +27473,5 @@
 diff -ruN ../netqmail-1.06-original/scan_xlong.c netqmail-1.06/scan_xlong.c
 --- ../netqmail-1.06-original/scan_xlong.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/scan_xlong.c	2016-11-22 21:03:57.127527599 +0100
++++ netqmail-1.06/scan_xlong.c	2019-02-27 20:57:13.405024904 +0100
 @@ -0,0 +1,47 @@
 +/*
@@ -27256,5 +27524,5 @@
 diff -ruN ../netqmail-1.06-original/select.h2 netqmail-1.06/select.h2
 --- ../netqmail-1.06-original/select.h2	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/select.h2	2016-11-22 21:03:57.127527599 +0100
++++ netqmail-1.06/select.h2	2019-02-27 20:57:13.405024904 +0100
 @@ -1,6 +1,12 @@
  #ifndef SELECT_H
@@ -27272,5 +27540,5 @@
 diff -ruN ../netqmail-1.06-original/socket_v4mappedprefix.c netqmail-1.06/socket_v4mappedprefix.c
 --- ../netqmail-1.06-original/socket_v4mappedprefix.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/socket_v4mappedprefix.c	2016-11-22 21:03:57.127527599 +0100
++++ netqmail-1.06/socket_v4mappedprefix.c	2019-02-27 20:57:13.406024893 +0100
 @@ -0,0 +1,9 @@
 +/*
@@ -27285,5 +27553,5 @@
 diff -ruN ../netqmail-1.06-original/socket_v6any.c netqmail-1.06/socket_v6any.c
 --- ../netqmail-1.06-original/socket_v6any.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/socket_v6any.c	2016-11-22 21:03:57.127527599 +0100
++++ netqmail-1.06/socket_v6any.c	2019-02-27 20:57:13.406024893 +0100
 @@ -0,0 +1,9 @@
 +/*
@@ -27298,5 +27566,5 @@
 diff -ruN ../netqmail-1.06-original/softwarelicense1-1.html netqmail-1.06/softwarelicense1-1.html
 --- ../netqmail-1.06-original/softwarelicense1-1.html	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/softwarelicense1-1.html	2016-11-22 21:03:57.128527565 +0100
++++ netqmail-1.06/softwarelicense1-1.html	2019-02-27 20:57:13.406024893 +0100
 @@ -0,0 +1,59 @@
 +<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
@@ -27361,5 +27629,5 @@
 diff -ruN ../netqmail-1.06-original/spawn-filter.9 netqmail-1.06/spawn-filter.9
 --- ../netqmail-1.06-original/spawn-filter.9	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/spawn-filter.9	2016-11-22 21:03:57.128527565 +0100
++++ netqmail-1.06/spawn-filter.9	2019-02-27 20:57:13.406024893 +0100
 @@ -0,0 +1,103 @@
 +.TH spawn-filter 8
@@ -27468,6 +27736,6 @@
 diff -ruN ../netqmail-1.06-original/spawn-filter.c netqmail-1.06/spawn-filter.c
 --- ../netqmail-1.06-original/spawn-filter.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/spawn-filter.c	2016-11-22 21:03:57.128527565 +0100
-@@ -0,0 +1,546 @@
++++ netqmail-1.06/spawn-filter.c	2020-04-09 19:45:45.390398843 +0200
+@@ -0,0 +1,506 @@
 +/*
 + * netqmail-version without spam filter
@@ -27635,30 +27903,8 @@
 +static int      run_mailfilter(char *, char *, char **);
 +int             wildmat_internal(char *, char *);
-+static int      check_size(char *);
 +
 +static int      remotE;
 +stralloc        sender = { 0 };
 +stralloc        recipient = { 0 };
-+
-+static int
-+check_size(char *size)
-+{
-+	char           *x;
-+	unsigned long   databytes = -1, msgsize;
-+
-+	if (!(x = env_get("DATABYTES")))
-+	{
-+		if (control_readulong(&databytes, "databytes") == -1)
-+			report(111, "spawn-filter: Unable to read databytes: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
-+	} else
-+		scan_ulong(x, &databytes);
-+	if (databytes == -1)
-+		return (0);
-+	scan_ulong(size, &msgsize);
-+	if (msgsize > databytes)
-+		return(1);
-+	else
-+		return(0);
-+}
 +
 +static void
@@ -27926,7 +28172,5 @@
 +main(int argc, char **argv)
 +{
-+	char           *ptr, *mailprog, *domain, *errStr = 0, *size = "0", *qqeh, *ext;
-+	char            sizebuf[FMT_ULONG];
-+	struct stat     statbuf;
++	char           *ptr, *mailprog, *domain, *ext;
 +	int             len;
 +
@@ -27939,16 +28183,9 @@
 +	{
 +		mailprog = "bin/qmail-local";
++		ext = argv[6];
 +		domain = argv[7];
-+		ext = argv[6];
-+		qqeh = argv[10];
 +		remotE = 0;
 +		if (!env_unset("QMAILREMOTE"))
 +			report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
-+		if (!fstat(0, &statbuf)) 
-+		{
-+			sizebuf[fmt_ulong(sizebuf, statbuf.st_size)] = 0;
-+			size = sizebuf;
-+		} else
-+			size = "0";
 +		/*- sender */
 +		if (!stralloc_copys(&sender, argv[8]))
@@ -27956,14 +28193,11 @@
 +		if (!stralloc_0(&sender))
 +			report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
-+		if (!env_unset("QMAILREMOTE"))
-+			report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
 +		/*- recipient */
-+		if (*ext) /*- EXT */
-+		{
++		if (*ext) { /*- EXT */
 +			if (!stralloc_copys(&recipient, ext))
 +				report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
 +		} else /*- user */
-+			if (!stralloc_copys(&recipient, argv[2]))
-+				report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
++		if (!stralloc_copys(&recipient, argv[2]))
++			report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
 +		if (!stralloc_cats(&recipient, "@"))
 +			report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
@@ -27977,7 +28211,4 @@
 +		mailprog = "bin/qmail-remote";
 +		domain = argv[1];
-+		ext = argv[5];
-+		qqeh = argv[3];
-+		size = argv[4];
 +		remotE = 1;
 +		if (!env_unset("QMAILLOCAL"))
@@ -27989,5 +28220,5 @@
 +			report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
 +		/*- recipient */
-+		if (!stralloc_copys(&recipient, argv[5]))
++		if (!stralloc_copys(&recipient, argv[3]))
 +			report(111, "spawn-filter: out of mem: ", error_str(errno), ". (#4.3.0)", 0, 0, 0);
 +		if (!stralloc_0(&recipient))
@@ -28000,7 +28231,4 @@
 +	if (chdir(auto_qmail) == -1)
 +		report(111, "spawn-filter: Unable to switch to ", auto_qmail, ": ", error_str(errno), ". (#4.3.0)", 0);
-+	/*- DATABYTES Check */
-+	if (check_size(size))
-+		report(100, "sorry, that message size exceeds my databytes limit (#5.3.4)", 0, 0, 0, 0, 0);
 +	run_mailfilter(domain, mailprog, argv);
 +	report(111, "spawn-filter: could not exec ", mailprog, ": ", error_str(errno), ". (#4.3.0)", 0);
@@ -28018,5 +28246,5 @@
 diff -ruN ../netqmail-1.06-original/spawn.c netqmail-1.06/spawn.c
 --- ../netqmail-1.06-original/spawn.c	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/spawn.c	2016-11-22 21:03:57.128527565 +0100
++++ netqmail-1.06/spawn.c	2019-02-27 20:57:13.407024882 +0100
 @@ -1,4 +1,4 @@
 -#include <sys/types.h>
@@ -28097,5 +28325,5 @@
 diff -ruN ../netqmail-1.06-original/spf.c netqmail-1.06/spf.c
 --- ../netqmail-1.06-original/spf.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/spf.c	2016-11-22 21:03:57.129527532 +0100
++++ netqmail-1.06/spf.c	2019-02-27 20:57:13.407024882 +0100
 @@ -0,0 +1,877 @@
 +#include "stralloc.h"
@@ -28978,5 +29206,5 @@
 diff -ruN ../netqmail-1.06-original/spf.h netqmail-1.06/spf.h
 --- ../netqmail-1.06-original/spf.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/spf.h	2016-11-22 21:03:57.129527532 +0100
++++ netqmail-1.06/spf.h	2019-02-27 20:57:13.407024882 +0100
 @@ -0,0 +1,20 @@
 +#ifndef SPF_H
@@ -29002,5 +29230,5 @@
 diff -ruN ../netqmail-1.06-original/spfquery.c netqmail-1.06/spfquery.c
 --- ../netqmail-1.06-original/spfquery.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/spfquery.c	2016-11-22 21:03:57.129527532 +0100
++++ netqmail-1.06/spfquery.c	2019-02-27 20:57:13.407024882 +0100
 @@ -0,0 +1,84 @@
 +#include "substdio.h"
@@ -29090,5 +29318,5 @@
 diff -ruN ../netqmail-1.06-original/srs.c netqmail-1.06/srs.c
 --- ../netqmail-1.06-original/srs.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/srs.c	2016-11-22 21:03:57.129527532 +0100
++++ netqmail-1.06/srs.c	2019-02-27 20:57:13.408024870 +0100
 @@ -0,0 +1,166 @@
 +#include <sys/types.h>
@@ -29260,5 +29488,5 @@
 diff -ruN ../netqmail-1.06-original/srs.h netqmail-1.06/srs.h
 --- ../netqmail-1.06-original/srs.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/srs.h	2016-11-22 21:03:57.129527532 +0100
++++ netqmail-1.06/srs.h	2019-02-27 20:57:13.408024870 +0100
 @@ -0,0 +1,9 @@
 +#ifndef SRS_H
@@ -29273,5 +29501,5 @@
 diff -ruN ../netqmail-1.06-original/srsfilter.c netqmail-1.06/srsfilter.c
 --- ../netqmail-1.06-original/srsfilter.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/srsfilter.c	2016-11-22 21:03:57.129527532 +0100
++++ netqmail-1.06/srsfilter.c	2019-02-27 20:57:13.408024870 +0100
 @@ -0,0 +1,137 @@
 +#include "sig.h"
@@ -29414,6 +29642,7 @@
 diff -ruN ../netqmail-1.06-original/ssl_timeoutio.c netqmail-1.06/ssl_timeoutio.c
 --- ../netqmail-1.06-original/ssl_timeoutio.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/ssl_timeoutio.c	2016-11-22 21:03:57.129527532 +0100
-@@ -0,0 +1,95 @@
++++ netqmail-1.06/ssl_timeoutio.c	2020-01-10 21:51:32.057157279 +0100
+@@ -0,0 +1,126 @@
++#ifdef TLS
 +#include "select.h"
 +#include "error.h"
@@ -29488,7 +29717,35 @@
 +int ssl_timeoutrehandshake(int t, int rfd, int wfd, SSL *ssl)
 +{
-+  int r;
-+
-+  SSL_renegotiate(ssl);
++  int r=0;
++
++#if OPENSSL_VERSION_NUMBER >= 0x10101000L
++  if (SSL_version(ssl) >= TLS1_3_VERSION){
++    if(SSL_verify_client_post_handshake(ssl) != 1)
++      return -EPROTO;
++  } else
++#endif
++  {
++    r =  SSL_renegotiate(ssl);
++    if (r<=0) return r;
++  }
++
++#if OPENSSL_VERSION_NUMBER >= 0x10001000L
++  char buf[1]; /* dummy read buffer */
++  struct timeval tv;
++  fd_set fds;
++  r = ssl_timeoutio(SSL_do_handshake, t, rfd, wfd, ssl, NULL, 0);
++  if (r <=0) return r;
++#if OPENSSL_VERSION_NUMBER >= 0x10101000L
++  if (SSL_version(ssl) >= TLS1_3_VERSION) return r;
++#endif
++
++  tv.tv_sec = (time_t)t; tv.tv_usec = 0;
++  FD_ZERO(&fds);  FD_SET(rfd, &fds);
++  if ((r = select(rfd + 1, &fds, NULL, NULL, &tv)>0) && FD_ISSET(rfd, &fds)){
++    r = SSL_read(ssl, buf, 1);
++    if (SSL_get_error(ssl, r) == SSL_ERROR_WANT_READ) r = 1; /*ignore */
++  }
++  if (r <=0) return r;
++#else
 +  r = ssl_timeoutio(SSL_do_handshake, t, rfd, wfd, ssl, NULL, 0);
 +  if (r <= 0 || ssl->type == SSL_ST_CONNECT) return r;
@@ -29496,4 +29753,5 @@
 +  /* this is for the server only */
 +  ssl->state = SSL_ST_ACCEPT;
++#endif
 +  return ssl_timeoutio(SSL_do_handshake, t, rfd, wfd, ssl, NULL, 0);
 +}
@@ -29511,7 +29769,8 @@
 +  return ssl_timeoutio(SSL_write, t, rfd, wfd, ssl, buf, len);
 +}
++#endif
 diff -ruN ../netqmail-1.06-original/ssl_timeoutio.h netqmail-1.06/ssl_timeoutio.h
 --- ../netqmail-1.06-original/ssl_timeoutio.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/ssl_timeoutio.h	2016-11-22 21:03:57.130527499 +0100
++++ netqmail-1.06/ssl_timeoutio.h	2019-04-07 13:05:52.192763950 +0200
 @@ -0,0 +1,21 @@
 +#ifndef SSL_TIMEOUTIO_H
@@ -29521,6 +29780,6 @@
 +
 +/* the version is like this: 0xMNNFFPPS: major minor fix patch status */
-+#if OPENSSL_VERSION_NUMBER < 0x00906000L
-+# error "Need OpenSSL version at least 0.9.6"
++#if OPENSSL_VERSION_NUMBER < 0x00908000L
++# error "Need OpenSSL version at least 0.9.8"
 +#endif
 +
@@ -29538,5 +29797,5 @@
 diff -ruN ../netqmail-1.06-original/str.h netqmail-1.06/str.h
 --- ../netqmail-1.06-original/str.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/str.h	2016-11-22 21:03:57.130527499 +0100
++++ netqmail-1.06/str.h	2019-02-27 20:57:13.408024870 +0100
 @@ -2,6 +2,11 @@
  #define STR_H
@@ -29565,5 +29824,5 @@
 diff -ruN ../netqmail-1.06-original/str_cpyb.c netqmail-1.06/str_cpyb.c
 --- ../netqmail-1.06-original/str_cpyb.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/str_cpyb.c	2016-11-22 21:03:57.130527499 +0100
++++ netqmail-1.06/str_cpyb.c	2019-02-27 20:57:13.408024870 +0100
 @@ -0,0 +1,53 @@
 +/*
@@ -29622,5 +29881,5 @@
 diff -ruN ../netqmail-1.06-original/str_cspn.c netqmail-1.06/str_cspn.c
 --- ../netqmail-1.06-original/str_cspn.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/str_cspn.c	2016-11-22 21:03:57.130527499 +0100
++++ netqmail-1.06/str_cspn.c	2019-02-27 20:57:13.408024870 +0100
 @@ -0,0 +1,40 @@
 +/*
@@ -29666,5 +29925,5 @@
 diff -ruN ../netqmail-1.06-original/strpidt.c netqmail-1.06/strpidt.c
 --- ../netqmail-1.06-original/strpidt.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/strpidt.c	2016-11-22 21:03:57.130527499 +0100
++++ netqmail-1.06/strpidt.c	2019-02-27 20:57:13.408024870 +0100
 @@ -0,0 +1,26 @@
 +/*
@@ -29696,5 +29955,5 @@
 diff -ruN ../netqmail-1.06-original/strsalloc.c netqmail-1.06/strsalloc.c
 --- ../netqmail-1.06-original/strsalloc.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/strsalloc.c	2016-11-22 21:03:57.130527499 +0100
++++ netqmail-1.06/strsalloc.c	2019-02-27 20:57:13.409024860 +0100
 @@ -0,0 +1,7 @@
 +#include "alloc.h"
@@ -29707,5 +29966,5 @@
 diff -ruN ../netqmail-1.06-original/strsalloc.h netqmail-1.06/strsalloc.h
 --- ../netqmail-1.06-original/strsalloc.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/strsalloc.h	2016-11-22 21:03:57.130527499 +0100
++++ netqmail-1.06/strsalloc.h	2019-02-27 20:57:13.409024860 +0100
 @@ -0,0 +1,12 @@
 +#ifndef STRSALLOC_H
@@ -29723,5 +29982,5 @@
 diff -ruN ../netqmail-1.06-original/strtimet.c netqmail-1.06/strtimet.c
 --- ../netqmail-1.06-original/strtimet.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/strtimet.c	2016-11-22 21:03:57.130527499 +0100
++++ netqmail-1.06/strtimet.c	2019-02-27 20:57:13.409024860 +0100
 @@ -0,0 +1,26 @@
 +/*
